##
# @api model
# Represents an autogenerated SSH key used by a component in the application to access other application gears.
# @see Application#process_commands
class ApplicationSshKey < SshKey
  include Mongoid::Document
  field :component_id, type: Moped::BSON::ObjectId
  embedded_in :application, class_name: Application.name

  def to_obj(args={})
    super
    self.component_id = args["component_id"] if args["component_id"]
    self
  end

  # This method should be implemented in the subclasses, if required
  def to_key_hash()
    key_hash = super
    key_hash["component_id"] = self.component_id
    key_hash
  end
end
